﻿using System;
using System.Reflection;

namespace ConsoleApp1
{
    enum MyEnum
    {
        A,
        B,
    }

    class Program
    {
        static void Main(string[] args)
        {
            object objValue = MyEnum.A;

            Program pg = new Program();
            pg.Test(objValue);
            pg.Test(MyEnum.A);

            pg.CallTest(objValue);
        }

        void CallTest(object objValue)
        {
            Type argType = objValue.GetType();

            MethodInfo mi = typeof(Program).GetMethod("Test", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);
            MethodInfo testMethod = mi.MakeGenericMethod(new Type[] { argType });

            testMethod.Invoke(this, new object[] { objValue });
        }

        void Test<T>(T objValue)
        {
            Type type = typeof(T);
            Console.WriteLine(type.FullName);
        }
    }
}
